//** Craig Laurent
#import <appkit/appkit.h>
#import <eointerface/eointerface.h>
@class Converse;

/* InfoController - an Object used to control the display of the info and preferences panels.  Control is also maintained over the interaction of the preferences panel and the data displayed from the Perferences and User Objects. */

@interface InfoController:NSObject
{
#ifdef IB
	id	infoPanel;
#else
	Panel	*infoPanel;
#endif

#ifdef IB
	id	preferencesPanel;
	id	swapBox;
#else
	Panel	*preferencesPanel;
	Box	*swapBox;
#endif

#ifdef IB
	id	swapMessageBox;
	id	alertAudibleCheck;
	id	alertIconCheck;
	id	alertWindowCheck;
	id	alertApplicationCheck;
	id	alertSoundField;
	id	defaultAddressField;
#else
	Box	*swapMessageBox;
	Button	*alertAudibleCheck;
	Button	*alertIconCheck;
	Button	*alertWindowCheck;
	Button	*alertApplicationCheck;
	TextField	*alertSoundField;
	TextField	*defaultAddressField;
#endif

#ifdef IB
	id	swapUserBox;
	id	machineNameField;
	id	realNameField;
	id	userIDField;
	id	machineNameCheck;
	id	realNameCheck;
	id	userIDCheck;
	id	nicknameField;
#else
	Box	*swapUserBox;
	TextField	*machineNameField;
	TextField	*realNameField;
	TextField	*userIDField;
	Button	*machineNameCheck;
	Button	*realNameCheck;
	Button	*userIDCheck;
	TextField	*nicknameField;
#endif

	Converse	*prefDataMaster;
}

- initWithPrefMaster:(Converse*)newMaster;
- init;
- (void)dealloc;
- awakeFromNib;

- showInfoPanel:sender;

- showPreferences:sender;
- (Converse*)prefDataMaster;
- (void)setPrefDataMaster:(Converse*)newMaster;
- swapMessage:sender;
- swapUser:sender;

- changeSoundFile:sender;
- changeAddressFile:sender;
- emptyAddressFile:sender;
- updateNickname:sender;
- changeTextEnable:sender;
- loadPref:sender;
- savePref:sender;

@end
