//** Craig Laurent
#import <appkit/appkit.h>
#import <eointerface/eointerface.h>

/* Preferences - an Object that maintains all application preference information.  The user can choose how to be alerted about an incoming message.
alertAudio	- a sound will play.
alertIcon	- the icon will "flash".
alertWindow	- the Window will be brought to the front.
alertApplication	- the Application will be made active.
The user can choose what information about users will be reflected in their log.
discloseId	- displays user's ID.
discloseName	- displays user's real name.
discloseMachine	- displays user's machine name.  */

@interface Preferences:NSObject
{
	BOOL alertAudio;
	BOOL alertIcon;
	BOOL alertWindow;
	BOOL alertApplication;

	BOOL discloseID;
	BOOL discloseName;
	BOOL discloseMachine;

	NSString	*soundFile;
	NSString	*addressFile;
}

- init;
- (void)dealloc;

//** instance methods
- (BOOL)alertAudio;
- (void)setAlertAudio:(BOOL)audio;
- (BOOL)alertIcon;
- (void)setAlertIcon:(BOOL)icon;
- (BOOL)alertWindow;
- (void)setAlertWindow:(BOOL)window;
- (BOOL)alertApplication;
- (void)setAlertApplication:(BOOL)application;

- (BOOL)discloseID;
- (void)setDiscloseID:(BOOL)dID;
- (BOOL)discloseName;
- (void)setDiscloseName:(BOOL)dName;
- (BOOL)discloseMachine;
- (void)setDiscloseMachine:(BOOL)dMachine;

- (NSString*)soundFile;
- (void)setSoundFile:(NSString*)file;
- (NSString*)addressFile;
- (void)setAddressFile:(NSString*)file;

//** method types
- (void)loadPreferences;
- (void)savePreferences;

@end
