//** Craig Laurent
#import <eointerface/eointerface.h>

//** extra code used for encoding User, a subclass of NSObject
@interface NSObject (NXTransportExtensions)
- encodeRemotelyFor:(NXConnection *)connection
freeAfterEncoding:(BOOL *)flagp isBycopy:(BOOL)isBycopy;
@end


/* User - an Object that maintains all information on a specific user.  This information is passed with messages to indicate who sent the message.  This information is displayed in the log along with the message.  Pertinent information is:
userID	- the user's computer ID.
userName	- the user's real name.
userMachine	- the user's machine name.
A nickname can be created which can contain all or none of these pieces of information. */

@interface User:NSObject
{
	NSString *userID;
	NSString *userName;
	NSString *userMachine;
}

- init;
- (void)dealloc;

//** instance methods
- (NSString *)userID;
- (void)setUserID:(NSString *)newID;
- (NSString *)userName;
- (void)setUserName:(NSString *)newName;
- (NSString *)userMachine;
- (void)setUserMachine:(NSString *)newMachine;

//** method types
- (void)loadUser;
- (NSString *)userNicknameWithID:(BOOL)ID andName:(BOOL)name andMachine:(BOOL)machine;

//** data archiving methods
- (void)encodeWithCoder:(NSCoder *)aCoder;
- initWithCoder:(NSCoder *)aDecoder;

//** Distributed Object methods
- encodeRemotelyFor:(NXConnection *)connection freeAfterEncoding:(BOOL *)flagp isBycopy:(BOOL)isBycopy;
- encodeUsing:(id <NXEncoding>)portal;
- decodeUsing:(id <NXDecoding>)portal;

@end
