/*
 *	IRC.app -- IRC client program for NEXTSTEP
 *	Copyright (C)1995 Norihiro Itoh
 *
 *	ΥIRC.appΰǤ
 *	This file is part of IRC.app.
 *
 *	ܥץϥե꡼եȥǤʤϡFree Software 
 *	FoundationɽGNU̸ͭѵΡ֥С󣲡װ
 *	ʹߤγƥС椫餤줫򤷡ΥС
 *	˽äܥץۤޤѹ뤳ȤǤ
 *	
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	ܥץͭѤȤϻפޤۤˤäƤϡԾڤ
 *	ŪŬˤĤƤΰۤݾڤޤơʤݾڤԤʤ
 *	󡣾ܺ٤ˤĤƤGNU̸ͭѵɤߤ
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	ʤϡܥץȰGNU̸ͭѵμ̤
 *	ƤϤǤǤʤϡFree Software Foundation, Inc.,
 *	675 Mass Ave, Cambridge, MA 02139, USAؼ񤤤Ƥ
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	ԤΥ᡼륢ɥ쥹: nito@scorpio.bekkoame.or.jp
 *	Author's e-mail address: nito@scorpio.bekkoame.or.jp
 */	

#import "MenuSupport.h"

@implementation IRCManager (MenuSupport)

- showInfo:sender
{
    if (info == nil) {
	if (![self loadNibSection:"info.nib" owner:self]) {
	    return nil;
	}
    }
    [info makeKeyAndOrderFront:nil];
    return self;
}

- showGPL:sender
{
    int		ret;
    char	path[MAXPATHLEN+1];
    port_t	port;
    id		speaker;

    if ([[NXBundle mainBundle] getPath:path
    		forResource:"GNUGPL" ofType:"rtf"]) {
	port = NXPortFromName("Edit", NULL);
	if (port != PORT_NULL) {
	    speaker = [NXApp appSpeaker];
	    [speaker setSendPort:port];
	    [speaker openFile:path ok:&ret];
	}
    }
    return self;
}

- sendMail:sender
{
    port_t	port;
    id		speaker;

    port = NXPortFromName("MailSendDemo", NULL);
    if (port != PORT_NULL) {
	speaker = [NXApp appSpeaker];
	[speaker setSendPort:port];
	[speaker selectorRPC:"setTo:" paramTypes:"c",
		[messageTable valueForStringKey:"MAIL_ADDRESS"]];
	[speaker selectorRPC:"setSubject:" paramTypes:"c",
		[messageTable valueForStringKey:"MAIL_SUBJECT"]];
	[speaker selectorRPC:"setBody:" paramTypes:"c",
		[messageTable valueForStringKey:"MAIL_BODY"]];
    }
    return self;
}

- print:sender
{
    id		window;
    id		manager;
    
    if ((window = [NXApp keyWindow]) == nil) {
    	NXBeep();
	return nil;
    }

    manager = [window delegate];
    if ([manager respondsTo:@selector(printDialogue:)] == YES)
	[manager printDialogue:nil];
    else
    	[window printPSCode:nil];
    return self;
}

- save:sender
{
    id		manager;
    
    manager = [[NXApp keyWindow] delegate];
    if ([manager respondsTo:@selector(saveDialogue:)] == YES)
	[manager saveDialogue:nil];
    else
    	NXBeep();
    return self;
}

- close:sender
{
    id		manager;
    
    manager = [[NXApp keyWindow] delegate];
    if ([manager respondsTo:@selector(closeDialogue:)] == YES)
	[manager closeDialogue:nil];
    else
    	NXBeep();
    return self;
}

@end
