/*
 *	IRC.app -- IRC client program for NEXTSTEP
 *	Copyright (C)1995 Norihiro Itoh
 *
 *	ΥIRC.appΰǤ
 *	This file is part of IRC.app.
 *
 *	ܥץϥե꡼եȥǤʤϡFree Software 
 *	FoundationɽGNU̸ͭѵΡ֥С󣲡װ
 *	ʹߤγƥС椫餤줫򤷡ΥС
 *	˽äܥץۤޤѹ뤳ȤǤ
 *	
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	ܥץͭѤȤϻפޤۤˤäƤϡԾڤ
 *	ŪŬˤĤƤΰۤݾڤޤơʤݾڤԤʤ
 *	󡣾ܺ٤ˤĤƤGNU̸ͭѵɤߤ
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	ʤϡܥץȰGNU̸ͭѵμ̤
 *	ƤϤǤǤʤϡFree Software Foundation, Inc.,
 *	675 Mass Ave, Cambridge, MA 02139, USAؼ񤤤Ƥ
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	ԤΥ᡼륢ɥ쥹: nito@scorpio.bekkoame.or.jp
 *	Author's e-mail address: nito@scorpio.bekkoame.or.jp
 */	

#import "PreferenceManager.h"

@implementation PreferenceManager

- showPreference:sender
{
    if (window == nil) {
	if (![NXApp loadNibSection:"preference.nib" owner:self]) {
	    return nil;
	}
    }
    [self readDefaults];
    [window makeKeyAndOrderFront:nil];
    return self;
}

- selectFile:sender
{
    // NOT SUPPORTED YET
    return self;
}

- set:sender
{
    [self writeDefaults];
    if ([[NXApp chatManager] connect:nil]) {
	[window orderOut:self];
	[NXApp showChannelPanel:nil];
    } else {
    	NXBeep();
    }
    return self;
}

- cancel:sender
{
    [window orderOut:self];
    return self;
}

- readDefaults
{
    const char		*dvalue;

    if (dvalue = NXReadDefault([NXApp appName], "ServerName")) {
    	[server setStringValue:dvalue];
    }

    if (dvalue = NXReadDefault([NXApp appName], "ServerPort")) {
    	[port setStringValue:dvalue];
    }

    if (dvalue = NXReadDefault([NXApp appName], "NickName")) {
    	[nickName setStringValue:dvalue];
    }

    if (dvalue = NXReadDefault([NXApp appName], "MailAddress")) {
    	[mailAddress setStringValue:dvalue];
    }

    if (dvalue = NXReadDefault([NXApp appName], "RealName")) {
    	[realName setStringValue:dvalue];
    }

    if (dvalue = NXReadDefault([NXApp appName], "ExecFileName")) {
  	[execFile setStringValue:dvalue];
    }
    return self;
}

- writeDefaults
{
    NXWriteDefault([NXApp appName], "ServerName", [server stringValue]);
    NXWriteDefault([NXApp appName], "ServerPort", [port stringValue]);
    NXWriteDefault([NXApp appName], "NickName", [nickName stringValue]);
    NXWriteDefault([NXApp appName], "MailAddress", [mailAddress stringValue]);
    NXWriteDefault([NXApp appName], "RealName", [realName stringValue]);
//  not supported yet....
//  NXWriteDefault([NXApp appName], "ExecFileName", [execFile stringValue]);
    return self;
}

- (const char *)server;
{
    const char		*dvalue;

    if (dvalue = NXReadDefault([NXApp appName], "ServerName")) {
    	return dvalue;
    } else {
    	return NULL;
    }
}

- (const char *)port;
{
    const char		*dvalue;

    if (dvalue = NXReadDefault([NXApp appName], "ServerPort")) {
    	return dvalue;
    } else {
    	return NULL;
    }
}

- (const char *)nickName;
{
    const char		*dvalue;

    if (dvalue = NXReadDefault([NXApp appName], "NickName")) {
    	return dvalue;
    } else {
    	return NULL;
    }
}

- (const char *)mailAddress
{
    const char		*dvalue;

    if (dvalue = NXReadDefault([NXApp appName], "MailAddress")) {
    	return dvalue;
    } else {
    	return NULL;
    }
}

- (const char *)realName;
{
    const char		*dvalue;

    if (dvalue = NXReadDefault([NXApp appName], "RealName")) {
    	return dvalue;
    } else {
    	return NULL;
    }
}

- (const char *)execFile
{
    const char		*dvalue;

    if (dvalue = NXReadDefault([NXApp appName], "ExecFileName")) {
  	return dvalue;
    } else {
    	return NULL;
    }
}
@end
