/*
 *	IRC.app -- IRC client program for NEXTSTEP
 *	Copyright (C)1995 Norihiro Itoh
 *
 *	ΥIRC.appΰǤ
 *	This file is part of IRC.app.
 *
 *	ܥץϥե꡼եȥǤʤϡFree Software 
 *	FoundationɽGNU̸ͭѵΡ֥С󣲡װ
 *	ʹߤγƥС椫餤줫򤷡ΥС
 *	˽äܥץۤޤѹ뤳ȤǤ
 *	
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	ܥץͭѤȤϻפޤۤˤäƤϡԾڤ
 *	ŪŬˤĤƤΰۤݾڤޤơʤݾڤԤʤ
 *	󡣾ܺ٤ˤĤƤGNU̸ͭѵɤߤ
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	ʤϡܥץȰGNU̸ͭѵμ̤
 *	ƤϤǤǤʤϡFree Software Foundation, Inc.,
 *	675 Mass Ave, Cambridge, MA 02139, USAؼ񤤤Ƥ
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *	ԤΥ᡼륢ɥ쥹: nito@scorpio.bekkoame.or.jp
 *	Author's e-mail address: nito@scorpio.bekkoame.or.jp
 */	

#import "TCPConnection.h"

@implementation TCPConnection

- init
{
    [super init];
    sock = -1;
    if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
	return nil;
    }
    return self;
}

- (int)connectTo:(char *)hostname by:(u_short)port
{
    struct hostent		*hp;
    struct sockaddr_in		sin;

    if ((hp = gethostbyname(hostname)) == NULL) {
	return TCP_UNKNOWN_HOST;
    }


    bzero((char*)&sin, sizeof(sin));
    sin.sin_family = AF_INET;
    sin.sin_port = htons(port);
    bcopy(hp->h_addr, &sin.sin_addr, hp->h_length);

    if (connect(sock, (struct sockaddr *)&sin, sizeof(sin)) < 0) {
	return TCP_CONNECT_FAILED;
    }
    return TCP_CONNECTED;
}

- (int)sendData:(char *)buffer sizeOf:(int)length
{
    int		nleft, nwritten;

    nwritten = 0;
    nleft = length;
    while (nleft > 0) {
	nwritten = write(sock, buffer, nleft);
	if (nwritten <= 0) return nwritten;	/* write error */
	nleft -= nwritten;
	buffer += nwritten;
    }
    return (nwritten - nleft);
}

- (int)receiveData:(char *)buffer sizeOf:(int)length
{
    int		nleft, nread;

    nleft = length;
    while (nleft > 0) {
	nread = read(sock, buffer, nleft);
	if (nread < 0) return nread;	/* read error */
	else if (nread == 0) break;
	nleft -= nread;
	buffer += nread;
    }
    return (length - nleft);
}

- (int)receiveLine:(char *)buffer
{
    int		n, rc;
    char	c;

    for (n = 1; n < 1025; n++) {
	if ((rc = read(sock, &c, 1)) == 1) {
	    *buffer++ = c;
	    if (c == '\n') break;
	} else if (rc == 0) {
	    if (n == 1) return 0;
	    else break;
	} else	return -1;
    }
    *buffer = 0;
    return n;
}

-(int)getFD
{
    return sock;
}

- shutDown
{
    shutdown(sock, 2);
    return self;
}

- close
{
    close(sock);
    return self;
}

- shutDownAndClose
{
    shutdown(sock, 2);
    close(sock);
    return self;
}

@end
