/* Kerberos Authentication Object */

/* state values for kinitStage state machine */
#define STARTED 1		/* started process */
#define GOTNAME 2		/* got 'Kerberos name: ' prompt */
#define SENTNAME 3		/* sent principal */
#define SENTREALM 5		/* sent realm */
#define SENTPASSWD 7		/* sent password */

#import <objc/Object.h>

@interface Kauth:Object
{
    id	authenticatePanel;
    id  authenticateButton;
    id	principalTextField;
    id	realmTextField;
    id	passwordTextField;
    id	kinitBannerTextField;
    id	infoPanel;
    id	klistReporter;
    id  kinitProcess;
    int kinitStage;
    char *outputBuffer;
}

- showAuthenticate:sender;
- authenticate:sender;
- showInfo:sender;
- saveDefaults:sender;

/* Subprocess Delegation */
- subprocessOutput:(char *)buffer;
- subprocessDone;
- subprocessError:(const char *)errorString;

/* Application Delegation */
- appDidInit:sender;
- appWillTerminate:sender;

@end
