
#import <appkit/appkit.h>

@protocol FtpResult

 - (void oneway) show:(const char *)string;
 - (void oneway) console:(const char *)string;
 - (void oneway) connected;
 - (void oneway) connectFailed:(const char *)error;
 - (void oneway) loggedIn;
 - (void oneway) loginFailed:(const char *)error;
 - (void oneway) checkingDir:dir;
 - (void oneway) listingDir:dir;
 - (void oneway) dirListed:dir;
 - (void oneway) retrievingFile:file;
 - (void oneway) fileRetrieved:file;
 - (void oneway) fileInterrupted:file;
- (void oneway) fileRetrievingFailed:(const char *)error;
- (void oneway) loggingOut;
- (void oneway) loggedOut;
 - (void oneway) transferError:obj:(const char *)error;
 - (void oneway) socketError:(const char *)error;
- (void oneway) unrecoverableError:(const char *)error;
 - (void oneway) connectionLost:(const char *)error;
 - (BOOL) shouldStopAtPosition:(long)pos;

@end

@interface FtpConnection:Object <FtpResult,NXSenderIsInvalid>
{
	id	ftpSub;
	id	session;
	id	queue;
	
	id	ftpHost;
	int connecttries;
	BOOL shouldinterrupt;
	enum {
		FTP_NOCONN,
		FTP_CONNECTED,
		//FTP_CONNNECTFAILED,
		FTP_LOGGEDIN,
		FTP_LISTINGDIR,
		FTP_GETTINGFILE,
		FTP_OK,
		FTP_ERROR,
		FTP_CONNECTIONLOST
	} status;
	id currentFile;
}

- initFromSession:aSession;
- free;

- senderIsInvalid:sender;

- addToQueue:obj;
- (BOOL)isInQueue:obj;

- ping;
- (BOOL)isTransferring;

- getDirForPath:(const char *)path;

/* Queue Browser Methods */
- (int) browser:sender fillMatrix:matrix inColumn:(int)column;
- singleClickInQueueBrowser:sender;
- doubleClickInQueueBrowser:sender;
- matrixDidShuffle:sender;

@end
