
#import <appkit/appkit.h>

@protocol FtpRequest

- (void oneway) setFtpConnection:obj;
- (void oneway) connectToHost:(const char *)name;
- (void oneway) loginAsUser:(const char *)user withPassword:(const char *)pass;
- (void oneway) listDir:dir;
- (void oneway) getFile:file;
- (void oneway) closeConnection;
@end

typedef enum {BINARY_MODE,ASCII_MODE} ftp_mode;

@interface FtpSubThread:Object <FtpRequest,NXSenderIsInvalid>
{
	id conn;
	int sock;
	char resbuf[1001];
	char recvbuf[1001];
	int recvpos,recvfullpos;
	char line[1001];
	struct sockaddr_in dataaddr;
	ftp_mode transfermode;
	NXAtom currentdir;
	long	lastshouldstoptime;
}

- senderIsInvalid:sender;
- (int) getResult;
- (int) putCommand:(const char *)s;
- (int) putCommand:(const char *)s1:(const char *)s2;
- (int) createPort;
- (int) acceptPort:(int) sock2;
- (char *) getLineFrom:(int) mysock;

@end
