#import "Article.h"
#import <appkit/appkit.h>
#import "NNTP.h"

#define FULL_HEADER 0
#define NO_HEADER 1
#define SMALL_HEADER 2
#define NEWSPAPER_HEADER 3
@interface ArticleViewControl:Object
{
    id theText;
    id nntpServer;
    id fromTextField;
    id imageView;
    id clockView;

    BOOL noArticle;
    char *articleHeader;
	 char *articleBody;

    int headerMode;	 
	 BOOL rewrapping;
	 BOOL signatureDetection;
	 BOOL quoteItalic;
	 
	 BOOL rot13;
	 const char	*subject,*from,*organization;
}	

- init;
- awakeFromNib;
- free;
- updateText;

- (int)loadArticle:(Article *)theArticle fromGroup:(const char *)theGroup;
- displayArticleScrollUp:(BOOL)scroll;
- clear;
- saveAs:sender;
- printText:sender;
- (id)theText;

- (const char *)articleBody;
- (const char *)articleHeader;

- writeBody:(NXStream *)aStream;
- writeQuotedText:(NXStream *)aStream;

- writeSelectedHeader;
- writeNewspaperHeader;

- showHeader:sender;
- hideHeader:sender;
- smallHeader:sender;
- newspaperHeader:sender;

- (BOOL)headermodeCellEnabled:menuCell;

- rot13:sender;

@end
