
#import <objc/Object.h>

@class MiscList, DBTableView, KVPair;

@protocol MiscTCRow

- (void *)insertKey:(const void *)aKey value:(void *)aValue;
- (void *)valueForKey:(const void *)aKey;

@end
	
@interface MiscTableController:Object
	{
	NXAtom		*identifiers;
	MiscList	*rows;
	DBTableView	*tableView;
	id			delegate;
	}
	
- init;

- (MiscList *)rows;
- (unsigned int)rowCount;

- setTableView:(DBTableView *)aView withIdentifiers:(NXAtom *)ids;
- (DBTableView *)tableView;
- (NXAtom *)identifiers;

- setDelegate:anObject;
- delegate;

- addRow:(id <MiscTCRow>)row;
- addRowsFrom:(List *)list;

- removeSelectedRow:sender;
- empty:sender;

- miscTableController:sender valueDidChangeFor:identifier at:(unsigned int)position;

@end


